unit DrBobPro;
interface
uses
  Classes, Provider;

type
  TBDataSetProvider = class(TDataSetProvider)
  public
    constructor Create(AOwner: TComponent); override;
    function GetRecords(Count: Integer;
                    out RecsOut: Integer): OleVariant; override;
  private
    FBytesTransferred: LongInt;
  public
    property BytesTransferred: LongInt read FBytesTransferred;
  end;

  procedure Register;

implementation

constructor TBDataSetProvider.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBytesTransferred := 0
end;

function TBDataSetProvider.GetRecords(Count: Integer;
                                  out RecsOut: Integer): OleVariant;
begin
  Result := inherited GetRecords(Count, RecsOut);
  if RecsOut > 0 then
    Inc(FBytesTransferred,DataSet.RecordSize * RecsOut);
  writeln(FBytesTransferred)
end;

procedure Register;
begin
  RegisterComponents('Dr.Bob',[TBDataSetProvider])
end;

end.